# Decorators

{% hint style="info" %}
This page contains the decoders that register functions with Tensorleap, upgraded from the previous [leap\_binder bindings](/tensorleap-integration/python-api/code_loader/leap_binder.md).
{% endhint %}

The Tensorleap decorators register the different functions that are required for Tensorleap to process and load your dataset: [**Preprocessing Function**](/tensorleap-integration/writing-integration-code/preprocess-function.md), [**Input Encoders**](/tensorleap-integration/writing-integration-code/input-encoder.md), [**Ground Truth Encoders**](/tensorleap-integration/writing-integration-code/ground-truth-encoder.md) and [**Metadata Functions**](/tensorleap-integration/writing-integration-code/metadata-function.md).

The **decorators** include:

* [@tensorleap\_preprocess](/tensorleap-integration/python-api/code_loader/decorators/tensorleap_preprocess.md)
* [@tensorleap\_input\_encoder](/tensorleap-integration/python-api/code_loader/decorators/tensorleap_input_encoder.md)
* [@tensorleap\_gt\_encoder](/tensorleap-integration/python-api/code_loader/decorators/tensorleap_gt_encoder.md)
* [@tensorleap\_custom\_loss](/tensorleap-integration/python-api/code_loader/decorators/tensorleap_custom_loss.md)
* [@tensorleap\_metadata](/tensorleap-integration/python-api/code_loader/decorators/tensorleap_metadata.md)
* [@tensorleap\_custom\_visualizer](/tensorleap-integration/python-api/code_loader/decorators/tensorleap_custom_visualizer.md)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.tensorleap.ai/tensorleap-integration/python-api/code_loader/decorators.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
